image: docker:latest

services:
  - docker:dind

variables:
  K8S_STABLE_VERSION_URL: https://dl.k8s.io/release/v1.18.14/bin/linux/amd64/kubectl

stages:
  - build
  - deploy

before_script:
  - echo "Log into Docker"
  - docker login $ACR_REGISTRY -u $DOCKER_USERNAME -p $DOCKER_PASSWORD

.build:
  # image: docker:latest
  # services:
  #   - docker:dind
  stage: build
  before_script:
    - echo "Log into Docker"
    - docker login $ACR_REGISTRY -u $DOCKER_USERNAME -p $DOCKER_PASSWORD
  script:
    - cd src/$SERVICE/
    - docker build -t $SERVICE:$VERSION .
    - docker tag $SERVICE:$VERSION $ACR_REGISTRY/$SERVICE:$VERSION
    - docker push $ACR_REGISTRY/$SERVICE:$VERSION

build-adservice:
  extends: .build
  variables:
    SERVICE: adservice
    VERSION: v1

build-cartservice:
  extends: .build
  variables:
    SERVICE: cartservice
    VERSION: v1

build-checkoutservice:
  extends: .build
  variables:
    SERVICE: checkoutservice
    VERSION: v1

build-currencyservice:
  extends: .build
  variables:
    SERVICE: currencyservice
    VERSION: v1

build-emailservice:
  extends: .build
  variables:
    SERVICE: emailservice
    VERSION: v1

build-frontend:
  extends: .build
  variables:
    SERVICE: frontend
    VERSION: v1

build-loadgenerator:
  extends: .build
  variables:
    SERVICE: loadgenerator
    VERSION: v1

build-paymentservice:
  extends: .build
  variables:
    SERVICE: paymentservice
    VERSION: v1

build-productcatalogservice:
  extends: .build
  variables:
    SERVICE: productcatalogservice
    VERSION: v1

build-recommendationservice:
  extends: .build
  variables:
    SERVICE: recommendationservice
    VERSION: v1

build-shippingservice:
  extends: .build
  variables:
    SERVICE: shippingservice
    VERSION: v1


deploy-k8s:
  stage: deploy
  # dependencies: 
  #   - build
  image: alpine
  before_script:
    - apk add --no-cache curl
    - apk add --no-cache openssl
    - apk add --no-cache bash
    - curl -LO $K8S_STABLE_VERSION_URL  #have to define K8S in the variable, same version v1.18.14
    - chmod +x ./kubectl
    - mv ./kubectl /usr/local/bin/kubectl
    - mkdir ~/.kube
    - echo $KUBE_CONFIG |base64 -d > config
    - cp config ~/.kube/config
    - kubectl cluster-info
    - curl -fsSL -o get_helm.sh https://raw.githubusercontent.com/helm/helm/master/scripts/get-helm-3
    - chmod 700 get_helm.sh
    - ./get_helm.sh
  script:
    - kubectl cluster-info
    - helm version
    - cd charts/
    - helm upgrade onlineboutique -f values.yaml .
  when: manual
  only:
    - master

# deploy-k8s:
#   stage: deploy
#   image: alpine/helm:3.5.1
#   before_script:
#     - helm version
#   script:
#     - cd charts/
#     - helm upgrade onlineboutique -f values.yaml .
#   when: manual
#   only:
#     - master